#include "IRremote/IRremote.h"
//IRrecv irrecv(12); 
//decode_results results;

#define BLSEN 9
#define BRSEN 11
#define FLSEN 10
#define FRSEN 8
#define REMOTE_SEN 12
#define EN1 6
#define EN2 5
#define IN1 7
#define IN2 4
#define ECHO 2
#define TRIG 3
#define DIST_THRESHOLD 50



int irstart(){
int result = 0;
  if (IrReceiver.decode()) {
     
     
      Serial.println(IrReceiver.decodedIRData.command, HEX);
      if (IrReceiver.decodedIRData.command==13){
          result = 1;
      }
      else {result = 0;}
      IrReceiver.resume(); 
  }

return result;

}

void Motor1(int pwm, boolean reverse) {
  analogWrite(EN1, pwm); //set pwm control, 0 for stop, and 255 for maximum speed
  if (reverse)  {
    digitalWrite(IN1, LOW);
  }
  else  {
    digitalWrite(IN1, HIGH);
  }
}

void Motor2(int pwm, boolean reverse) {
  analogWrite(EN2, pwm);
  if (reverse)  {
    digitalWrite(IN2, HIGH);
  }
  else  {
    digitalWrite(IN2, LOW);
  }
}

void forward(int sp1, int sp2){
  Motor1(abs(sp1), sp1<0);
  Motor2(abs(sp2), sp2<0);
  
  }


void setup() {
  // put your setup code here, to run once:
int robot_start = 0;
Serial.begin(9600);
IrReceiver.begin(12, ENABLE_LED_FEEDBACK);
pinMode (BLSEN, INPUT);
pinMode (BRSEN, INPUT);
pinMode (FLSEN, INPUT);
pinMode (FRSEN, INPUT);
pinMode (REMOTE_SEN, INPUT);
pinMode(EN1, OUTPUT);
pinMode(EN2, OUTPUT);
pinMode(IN1, OUTPUT);
pinMode(IN2, OUTPUT);
pinMode(TRIG, OUTPUT);
pinMode(ECHO, INPUT);
while (!robot_start){
  robot_start = irstart();
}
//Serial.println(robot_start);
}

void loop() {
  // put your main code here, to run repeatedly:
int found = search();
if (found) {attack();}
}

uint8_t isEdge(){
return (~PINB & B1111);

}

int isFound() {
  digitalWrite(TRIG, LOW);
  delayMicroseconds(5);
  digitalWrite(TRIG, HIGH);
  delayMicroseconds(10);
  digitalWrite(TRIG, LOW);
  int duration = pulseIn(ECHO, HIGH);
  int distance_cm = (duration / 2) / 29.1;
  if (distance_cm < DIST_THRESHOLD) {
      return 1;
      }
  else {
      return 0;
      }
}

void ifEdge(uint8_t sens){
  if (sens == 5){forward(-250,-250);delay(1500);forward(0,0);return;}
  if (sens == 1){forward(-150,-250);delay(1500);forward(0,0);return;}
  if (sens == 4){forward(-250,-150);delay(1500);forward(0,0);return;}
  if (sens == 10){forward(250,250);delay(1500);forward(0,0);return;}
  if (sens == 8){forward(150,250);delay(1500);forward(0,0);return;}
  if (sens == 2){forward(250,150);delay(1500);forward(0,0);return;}
  if (sens == 9){forward(50,250);delay(2000);forward(0,0);return;}
  if (sens == 6){forward(250,50);delay(2000);forward(0,0);return;}

return;
}

uint8_t search(){
  unsigned long tsearch = millis();
  static uint8_t dir_search=0;
  static unsigned long t_dir_search = millis();
  if (millis()-t_dir_search>15000){
    t_dir_search = millis();
    dir_search =!dir_search;
  }
  while (millis()-tsearch<15000){
    if (dir_search) {forward(250,-250);}
    else
    {forward(-250,250);}
    if (isFound()){return 1;}
    if (isEdge()){ifEdge(isEdge());}
  }
  tsearch = millis();
  while (millis()-tsearch<4){
    forward(250,250);
    if (isFound()){return 1;}
    if (isEdge()){ifEdge(isEdge());}
  }
  return 0;
}

uint8_t attack(){
 
 while (isFound()){
    forward(250,250);
    if (isEdge()){ifEdge(isEdge());}
    }
    
  return 0;
}
